Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -1116,62 +1650,96 @@
   (funcall font-lock-unfontify-region-function beg end loudly))
 
 (defun font-lock-default-fontify-buffer ()
-  (interactive)
-  ;; if we don't widen, then the C code will fail to
-  ;; realize that we're inside a comment.
-  (save-restriction
-    (widen)
-    (let ((was-on font-lock-mode)
-	  (font-lock-verbose (or font-lock-verbose (interactive-p)))
-	  (font-lock-message-threshold 0)
-	  (aborted nil))
-      ;; Turn it on to run hooks and get the right font-lock-keywords.
-      (or was-on (font-lock-mode 1))
-      (font-lock-unfontify-region (point-min) (point-max) t)
-      ;;    (buffer-syntactic-context-flush-cache)
-    
-      ;; If a ^G is typed during fontification, abort the fontification, but
-      ;; return normally (do not signal.)  This is to make it easy to abort
-      ;; fontification if it's taking a long time, without also causing the
-      ;; buffer not to pop up.  If a real abort is desired, the user can ^G
-      ;; again.
-      ;;
-      ;; Possibly this should happen down in font-lock-fontify-region instead
-      ;; of here, but since that happens from the after-change-hook (meaning
-      ;; much more frequently) I'm afraid of the bad consequences of stealing
-      ;; the interrupt character at inopportune times.
-      ;;
-      (condition-case nil
-	  (save-excursion
-	    (font-lock-fontify-region (point-min) (point-max)))
-	(t
-	 (setq aborted t)))
-
-      (or was-on			; turn it off if it was off.
-	  (let ((font-lock-fontified nil)) ; kludge to prevent defontification
-	    (font-lock-mode 0)))
-      (set (make-local-variable 'font-lock-fontified) t)
-      (when (and aborted font-lock-verbose)
-	(progress-feedback-with-label 'font-lock "Fontifying %s... aborted."
-				      'abort (buffer-name))))
-    (run-hooks 'font-lock-after-fontify-buffer-hook)))
+  (let* (
+	 ;; XEmacs addition: Various stuff relating to messages.  Sync
+	 ;; carefully!
+	 (font-lock-verbose (or font-lock-verbose (interactive-p)))
+	 (verbose (if (numberp font-lock-verbose)
+		      (> (buffer-size) font-lock-verbose)
+		    font-lock-verbose))
+	 aborted)
+    (unwind-protect
+	(progn
+	  (when verbose
+	    (progress-feedback-with-label 'font-lock "Fontifying %s..." 0
+					  (buffer-name)))
+	  ;; Make sure we have the right `font-lock-keywords' etc.
+	  (unless font-lock-mode
+	    (font-lock-set-defaults))
+	  ;; Make sure we fontify etc. in the whole buffer.
+	  (save-restriction
+	    (widen)
+	    ;;    (buffer-syntactic-context-flush-cache)
+	    ;; If a ^G is typed during fontification, abort the
+	    ;; fontification, but return normally (do not signal.)  This is
+	    ;; to make it easy to abort fontification if it's taking a long
+	    ;; time, without also causing the buffer not to pop up.  If a
+	    ;; real abort is desired, the user can ^G
+	    ;; again.
+	    ;;
+	    ;; Possibly this should happen down in font-lock-fontify-region
+	    ;; instead of here, but since that happens from the
+	    ;; after-change-hook (meaning much more frequently) I'm afraid
+	    ;; of the bad consequences of stealing the interrupt character
+	    ;; at inopportune times.
+	    ;;
+	    (condition-case nil
+		(save-excursion
+		  (save-match-data
+		    (font-lock-fontify-region (point-min) (point-max) verbose)
+		    (font-lock-after-fontify-buffer)
+		    (setq font-lock-fontified t)))
+	      ;; We don't restore the old fontification, so it's best to
+	      ;; unfontify.
+	      (quit (setq aborted t) (font-lock-unfontify-buffer))))
+	  ;; Make sure we undo `font-lock-keywords' etc.
+	  (unless font-lock-mode
+	    (font-lock-unset-defaults)))
+      (when verbose
+	(if aborted
+	    (progress-feedback-with-label 'font-lock
+					  "Fontifying %s... aborted."
+					  'abort (buffer-name))
+	  (clear-progress-feedback 'font-lock))))))
 
 (defun font-lock-default-unfontify-buffer ()
-  (font-lock-unfontify-region (point-min) (point-max))
-  (set (make-local-variable 'font-lock-fontified) nil))
+  ;; Make sure we unfontify etc. in the whole buffer.
+  (save-restriction
+    (widen)
+    (font-lock-unfontify-region (point-min) (point-max))
+    (font-lock-after-unfontify-buffer)
+    (setq font-lock-fontified nil)))
 
 ;; This used to be `font-lock-fontify-region', and before that,
 ;; `font-lock-fontify-region' used to be the name used for what is now
 ;; `font-lock-fontify-syntactically-region'.
 (defun font-lock-default-fontify-region (beg end &optional loudly)
-  (let ((modified (buffer-modified-p))
-	(buffer-undo-list t) (inhibit-read-only t)
-	(old-syntax-table (syntax-table))
-	buffer-file-name buffer-file-truename)
+  (save-buffer-state
+      ((parse-sexp-lookup-properties font-lock-syntactic-keywords)
+       (old-syntax-table (syntax-table)))
     (unwind-protect
-	(progn
+	(save-restriction
+	  (widen)
 	  ;; Use the fontification syntax table, if any.
-	  (if font-lock-syntax-table (set-syntax-table font-lock-syntax-table))
+	  (when font-lock-syntax-table
+	    (set-syntax-table font-lock-syntax-table))
+	  ;; check to see if we should expand the beg/end area for
+	  ;; proper multiline matches
+	  (when (and font-lock-multiline
+		     (> beg (point-min))
+		     (get-text-property (1- beg) 'font-lock-multiline))
+	    ;; We are just after or in a multiline match.
+	    (setq beg (or (previous-single-property-change
+			   beg 'font-lock-multiline)
+			  (point-min)))
+	    (goto-char beg)
+	    (setq beg (line-beginning-position)))
+	  (when font-lock-multiline
+	    (setq end (or (text-property-any end (point-max)
+					     'font-lock-multiline nil)
+			  (point-max))))
+	  (goto-char end)
+	  (setq end (line-beginning-position 2))
 	  ;; Now do the fontification.
 	  (font-lock-unfontify-region beg end)
 	  (when font-lock-syntactic-keywords
@@ -1180,8 +1748,7 @@
 	    (font-lock-fontify-syntactically-region beg end loudly))
 	  (font-lock-fontify-keywords-region beg end loudly))
       ;; Clean up.
-      (set-syntax-table old-syntax-table)
-      (and (not modified) (buffer-modified-p) (set-buffer-modified-p nil)))))
+      (set-syntax-table old-syntax-table))))
 
 ;; The following must be rethought, since keywords can override fontification.
 ;      ;; Now scan for keywords, but not if we are inside a comment now.
@@ -1191,16 +1758,17 @@
 ;		 (or (nth 4 state) (nth 7 state))))
 ;	  (font-lock-fontify-keywords-region beg end))
 
-(defun font-lock-default-unfontify-region (beg end &optional maybe-loudly)
-  (when (and maybe-loudly font-lock-verbose
+(defun font-lock-default-unfontify-region (beg end &optional loudly)
+  (when (and loudly
 	     (>= (- end beg) font-lock-message-threshold))
     (progress-feedback-with-label 'font-lock "Fontifying %s..." 0
 				  (buffer-name)))
-  (let ((modified (buffer-modified-p))
-	(buffer-undo-list t) (inhibit-read-only t)
-	buffer-file-name buffer-file-truename)
+  (save-buffer-state nil
     (font-lock-remove-face beg end)
-    (and (not modified) (buffer-modified-p) (set-buffer-modified-p nil))))
+    (remove-text-properties beg end
+			    (if font-lock-syntactic-keywords
+				'(syntax-table nil font-lock-multiline nil)
+			      '(font-lock-multiline nil)))))
 
 ;; Following is the original FSF version (similar to our original
 ;; version, before the deferred stuff was added).
@@ -1209,13 +1777,14 @@
 ;; Those efforts should be merged.
 
 ;; Called when any modification is made to buffer text.
-;(defun font-lock-after-change-function (beg end old-len)
-;  (save-excursion
-;    (save-match-data
-;      ;; Rescan between start of line from `beg' and start of line after `end'.
-;      (font-lock-fontify-region
-;	(progn (goto-char beg) (beginning-of-line) (point))
-;	(progn (goto-char end) (forward-line 1) (point))))))
+; (defun font-lock-after-change-function (beg end old-len)
+;   (let ((inhibit-point-motion-hooks t))
+;     (save-excursion
+;       (save-match-data
+; 	;; Rescan between start of lines enclosing the region.
+; 	(font-lock-fontify-region
+; 	 (progn (goto-char beg) (beginning-of-line) (point))
+; 	 (progn (goto-char end) (forward-line 1) (point)))))))
 
 (defvar font-lock-always-fontify-immediately nil
   "Set this to non-nil to disable font-lock deferral.
@@ -1310,93 +1879,42 @@
 		      (font-lock-fontify-region beg end))
 		  font-lock-range-table))))))
      font-lock-pending-buffer-table)))
-
-;; Syntactic fontification functions.
 
-(defun font-lock-lisp-like (mode)
-  ;; Note: (or (get mode 'font-lock-lisp-like) (string-match ...)) is
-  ;; not enough because the property needs to be able to specify a nil
-  ;; value.
-  (if (plist-member (symbol-plist mode) 'font-lock-lisp-like)
-      (get mode 'font-lock-lisp-like)
-    ;; If the property is not specified, guess.  Similar logic exists
-    ;; in add-log, but I think this encompasses more modes.
-    (string-match "lisp\\|scheme" (symbol-name mode))))
-
-;; fontify-syntactically-region used to use syntactically-sectionize, which
-;; was supposedly much faster than the FSF version because it was written in
-;; C. However, the FSF version uses parse-partial-sexp, which is also
-;; written in C, and the benchmarking I did showed the
-;; syntactically-sectionize code to be slower overall. So here's the FSF
-;; version, modified to support font-lock-doc-string-face.
-;; -- mct 2000-12-29
-(defun font-lock-fontify-syntactically-region (start end &optional loudly)
-  "Put proper face on each string and comment between START and END.
-START should be at the beginning of a line."
-  (if font-lock-keywords-only
-      nil
+(defun font-lock-fontify-block (&optional arg)
+  "Fontify some lines the way `font-lock-fontify-buffer' would.
+The lines could be a function or paragraph, or a specified number of lines.
+If ARG is given, fontify that many lines before and after point, or 16 lines if
+no ARG is given and `font-lock-mark-block-function' is nil.
+If `font-lock-mark-block-function' non-nil and no ARG is given, it is used to
+delimit the region to fontify."
+  (interactive "P")
+  (let (;FSF 21.2 (inhibit-point-motion-hooks t)
+	font-lock-beginning-of-syntax-function
+	;FSF 21.2 deactivate-mark
+	)
+    ;; Make sure we have the right `font-lock-keywords' etc.
+    (if (not font-lock-mode) (font-lock-set-defaults))
+    (save-excursion
+      (save-match-data
+	(condition-case error-data
+	    (if (or arg (not font-lock-mark-block-function))
+		(let ((lines (if arg (prefix-numeric-value arg) 16)))
+		  (font-lock-fontify-region
+		   (save-excursion (forward-line (- lines)) (point))
+		   (save-excursion (forward-line lines) (point))))
+	      (funcall font-lock-mark-block-function)
+	      (font-lock-fontify-region (point) (mark)))
+	  ((error quit) (message "Fontifying block...%s" error-data)))))))
 
-    ;; #### Shouldn't this just be using 'loudly??
-    (when (and font-lock-verbose
-	       (>= (- end start) font-lock-message-threshold))
-      (progress-feedback-with-label 'font-lock
-				    "Fontifying %s... (syntactically)" 5
-				    (buffer-name)))
-    (goto-char start)
+;; FSF 21.2.
+;;(define-key facemenu-keymap "\M-g" 'font-lock-fontify-block)
 
-    (let ((lisp-like (font-lock-lisp-like major-mode))
-	  (cache (marker-position font-lock-cache-position))
-	  state string beg depth)
-      ;;
-      ;; Find the state at the `beginning-of-line' before `start'.
-      (if (eq start cache)
-	  ;; Use the cache for the state of `start'.
-	  (setq state font-lock-cache-state)
-	;; Find the state of `start'.
-	(if (null font-lock-beginning-of-syntax-function)
-	    ;; Use the state at the previous cache position, if any, or
-	    ;; otherwise calculate from `point-min'.
-	    (if (or (null cache) (< start cache))
-		(setq state (parse-partial-sexp (point-min) start))
-	      (setq state (parse-partial-sexp cache start nil nil
-					      font-lock-cache-state)))
-	  ;; Call the function to move outside any syntactic block.
-	  (funcall font-lock-beginning-of-syntax-function)
-	  (setq state (parse-partial-sexp (point) start)))
-	;; Cache the state and position of `start'.
-	(setq font-lock-cache-state state)
-	(set-marker font-lock-cache-position start))
-      ;;
-      ;; If the region starts inside a string or comment, show the extent of it.
-      (when (or (nth 3 state) (nth 4 state))
-	(setq string (nth 3 state) beg (point))
-	(setq state (parse-partial-sexp (point) end nil nil state 'syntax-table))
-	(font-lock-set-face beg (point) (if string 
-					    font-lock-string-face
-					  font-lock-comment-face)))
-      ;;
-      ;; Find each interesting place between here and `end'.
-      (while (and (< (point) end)
-		  (progn
-		    (setq state (parse-partial-sexp (point) end nil nil state
-						    'syntax-table))
-		    (or (nth 3 state) (nth 4 state))))
-	(setq depth (nth 0 state) string (nth 3 state) beg (nth 8 state))
-	(setq state (parse-partial-sexp (point) end nil nil state 'syntax-table))
-	(if string
-	    ;; #### It would be nice if we handled Python and other
-	    ;; non-Lisp languages with docstrings correctly.
-	    (let ((face (if (and lisp-like (= depth 1))
-			    'font-lock-doc-string-face
-			  'font-lock-string-face)))
-	      (if font-lock-fontify-string-delimiters
-		  (font-lock-set-face beg (point) face)
-		(font-lock-set-face (+ beg 1) (- (point) 1) face)))
-	  (font-lock-set-face beg (point)
-			      font-lock-comment-face))))))
+;;; End of Fontification functions.
 
 ;;; Additional text property functions.
 
+;;;; We write:
+
 ;; The following three text property functions are not generally available (and
 ;; it's not certain that they should be) so they are inlined for speed.
 ;; The case for `fillin-text-property' is simple; it may or not be generally
@@ -1411,17 +1929,17 @@
 ;; the first one to take both SETPROP and MARKPROP, in accordance with the
 ;; changed definitions of `font-lock-any-faces-p' and `font-lock-set-face'.
 
-(defsubst font-lock-fillin-text-property (start end setprop markprop value &optional object)
-  "Fill in one property of the text from START to END.
-Arguments PROP and VALUE specify the property and value to put where none are
-already in place.  Therefore existing property values are not overwritten.
-Optional argument OBJECT is the string or buffer containing the text."
-  (let ((start (text-property-any start end markprop nil object)) next)
-    (while start
-      (setq next (next-single-property-change start markprop object end))
-      (put-nonduplicable-text-property start next setprop value object)
-      (put-nonduplicable-text-property start next markprop value object)
-      (setq start (text-property-any next end markprop nil object)))))
+;;;; FSF writes:
+
+;; The following text property functions should be builtins.  This means they
+;; should be written in C and put with all the other text property functions.
+;; In the meantime, those that are used by font-lock.el are defined in Lisp
+;; below and given a `font-lock-' prefix.  Those that are not used are defined
+;; in Lisp below and commented out.  sm.
+
+;;;; XEmacs: We also have some additions here: call font-lock-unique in
+;;;; certain places, allow for two different properties in
+;;;; font-lock-fillin-text-property.
 
 ;; This function (from simon's unique.el) is rewritten and inlined for speed.
 ;(defun unique (list function)
@@ -1476,6 +1994,52 @@
        (font-lock-unique (append (if (listp prev) prev (list prev)) val))
        object)
       (setq start next))))
+
+(defsubst font-lock-fillin-text-property (start end setprop markprop value &optional object)
+  "Fill in one property of the text from START to END.
+Arguments PROP and VALUE specify the property and value to put where none are
+already in place.  Therefore existing property values are not overwritten.
+Optional argument OBJECT is the string or buffer containing the text."
+  (let ((start (text-property-any start end markprop nil object)) next)
+    (while start
+      (setq next (next-single-property-change start markprop object end))
+      (put-nonduplicable-text-property start next setprop value object)
+      (put-nonduplicable-text-property start next markprop value object)
+      (setq start (text-property-any next end markprop nil object)))))
+
+;; For completeness: this is to `remove-text-properties' as `put-text-property'
+;; is to `add-text-properties', etc.
+;(defun remove-text-property (start end property &optional object)
+;  "Remove a property from text from START to END.
+;Argument PROPERTY is the property to remove.
+;Optional argument OBJECT is the string or buffer containing the text.
+;Return t if the property was actually removed, nil otherwise."
+;  (remove-text-properties start end (list property) object))
+
+;; For consistency: maybe this should be called `remove-single-property' like
+;; `next-single-property-change' (not `next-single-text-property-change'), etc.
+;(defun remove-single-text-property (start end prop value &optional object)
+;  "Remove a specific property value from text from START to END.
+;Arguments PROP and VALUE specify the property and value to remove.  The
+;resulting property values are not equal to VALUE nor lists containing VALUE.
+;Optional argument OBJECT is the string or buffer containing the text."
+;  (let ((start (text-property-not-all start end prop nil object)) next prev)
+;    (while start
+;      (setq next (next-single-property-change start prop object end)
+;	    prev (get-text-property start prop object))
+;      (cond ((and (symbolp prev) (eq value prev))
+;	     (remove-text-property start next prop object))
+;	    ((and (listp prev) (memq value prev))
+;	     (let ((new (delq value prev)))
+;	       (cond ((null new)
+;		      (remove-text-property start next prop object))
+;		     ((= (length new) 1)
+;		      (put-text-property start next prop (car new) object))
+;		     (t
+;		      (put-text-property start next prop new object))))))
+;      (setq start (text-property-not-all next end prop nil object)))))
+
+;;; End of Additional text property functions.
 
 ;;; Syntactic regexp fontification functions (taken from FSF Emacs 20.7.1)
 
@@ -1492,17 +2056,29 @@
 HIGHLIGHT should be of the form MATCH-HIGHLIGHT,
 see `font-lock-syntactic-keywords'."
   (let* ((match (nth 0 highlight))
- 	 (start (match-beginning match)) (end (match-end match))
- 	 (value (nth 1 highlight))
- 	 (override (nth 2 highlight)))
-    (unless (numberp (car-safe value))
+	 (start (match-beginning match)) (end (match-end match))
+	 (value (nth 1 highlight))
+	 (override (nth 2 highlight)))
+    (when (and (consp value) (not (numberp (car value))))
       (setq value (eval value)))
+    (when (stringp value) (setq value (string-to-syntax value)))
     (cond ((not start)
  	   ;; No match but we might not signal an error.
  	   (or (nth 3 highlight)
  	       (error "No match %d in highlight %S" match highlight)))
  	  ((not override)
+	   ;; FSF 21.2 version. #### Need to investigate here the use of
+	   ;; map-extents vs. text-property-not-all, which should be just
+	   ;; as fast, if not faster.
  	   ;; Cannot override existing fontification.
+; 	   (or (text-property-not-all start end 'syntax-table nil)
+; 	       (put-text-property start end 'syntax-table value)))
+; 	  ((eq override t)
+; 	   ;; Override existing fontification.
+; 	   (put-text-property start end 'syntax-table value))
+; 	  ((eq override 'keep)
+; 	   ;; Keep existing fontification.
+; 	   (font-lock-fillin-text-property start end 'syntax-table value)))))
  	   (or (map-extents 'extent-property (current-buffer)
 			    start end 'syntax-table)
 	       (font-lock-set-syntax start end value)))
@@ -1516,66 +2092,163 @@
 
 (defun font-lock-fontify-syntactic-anchored-keywords (keywords limit)
   "Fontify according to KEYWORDS until LIMIT.
- KEYWORDS should be of the form MATCH-ANCHORED, see `font-lock-keywords',
- LIMIT can be modified by the value of its PRE-MATCH-FORM."
+KEYWORDS should be of the form MATCH-ANCHORED, see `font-lock-keywords',
+LIMIT can be modified by the value of its PRE-MATCH-FORM."
   (let ((matcher (nth 0 keywords)) (lowdarks (nthcdr 3 keywords)) highlights
- 	;; Evaluate PRE-MATCH-FORM.
- 	(pre-match-value (eval (nth 1 keywords))))
+	;; Evaluate PRE-MATCH-FORM.
+	(pre-match-value (eval (nth 1 keywords))))
     ;; Set LIMIT to value of PRE-MATCH-FORM or the end of line.
     (if (and (numberp pre-match-value) (> pre-match-value (point)))
- 	(setq limit pre-match-value)
-      (save-excursion (end-of-line) (setq limit (point))))
+	(setq limit pre-match-value)
+      (setq limit (line-end-position)))
     (save-match-data
       ;; Find an occurrence of `matcher' before `limit'.
       (while (if (stringp matcher)
- 		 (re-search-forward matcher limit t)
- 	       (funcall matcher limit))
- 	;; Apply each highlight to this instance of `matcher'.
- 	(setq highlights lowdarks)
- 	(while highlights
- 	  (font-lock-apply-syntactic-highlight (car highlights))
- 	  (setq highlights (cdr highlights)))))
+		 (re-search-forward matcher limit t)
+	       (funcall matcher limit))
+	;; Apply each highlight to this instance of `matcher'.
+	(setq highlights lowdarks)
+	(while highlights
+	  (font-lock-apply-syntactic-highlight (car highlights))
+	  (setq highlights (cdr highlights)))))
     ;; Evaluate POST-MATCH-FORM.
     (eval (nth 2 keywords))))
 
 (defun font-lock-fontify-syntactic-keywords-region (start end)
   "Fontify according to `font-lock-syntactic-keywords' between START and END.
+START should be at the beginning of a line."
+  ;; Ensure the beginning of the file is properly syntactic-fontified.
+  (when (and font-lock-syntactically-fontified
+	     (< font-lock-syntactically-fontified start))
+    (setq start (max font-lock-syntactically-fontified (point-min)))
+    (setq font-lock-syntactically-fontified end))
+  ;; If `font-lock-syntactic-keywords' is a symbol, get the real keywords.
+  (when (symbolp font-lock-syntactic-keywords)
+    (setq font-lock-syntactic-keywords (font-lock-eval-keywords
+					font-lock-syntactic-keywords)))
+  ;; If `font-lock-syntactic-keywords' is not compiled, compile it.
+  (unless (eq (car font-lock-syntactic-keywords) t)
+    (setq font-lock-syntactic-keywords (font-lock-compile-keywords
+					font-lock-syntactic-keywords)))
+  ;; Get down to business.
+  (let ((case-fold-search font-lock-keywords-case-fold-search)
+	(keywords (cdr font-lock-syntactic-keywords))
+	keyword matcher highlights)
+    (while keywords
+      ;; Find an occurrence of `matcher' from `start' to `end'.
+      (setq keyword (car keywords) matcher (car keyword))
+      (goto-char start)
+      (while (if (stringp matcher)
+		 (re-search-forward matcher end t)
+	       (funcall matcher end))
+	;; Apply each highlight to this instance of `matcher', which may be
+	;; specific highlights or more keywords anchored to `matcher'.
+	(setq highlights (cdr keyword))
+	(while highlights
+	  (if (numberp (car (car highlights)))
+	      (font-lock-apply-syntactic-highlight (car highlights))
+	    (font-lock-fontify-syntactic-anchored-keywords (car highlights)
+							   end))
+	  (setq highlights (cdr highlights))))
+      (setq keywords (cdr keywords)))))
+
+;;; End of Syntactic regexp fontification functions.
+
+
+;; Syntactic fontification functions.
+
+;; These record the parse state at a particular position, always the start of a
+;; line.  Used to make `font-lock-fontify-syntactically-region' faster.
+;; Previously, `font-lock-cache-position' was just a buffer position.  However,
+;; under certain situations, this occasionally resulted in mis-fontification.
+;; I think the "situations" were deletion with Lazy Lock mode's deferral.  sm.
+(defvar font-lock-cache-state nil)
+(defvar font-lock-cache-position nil)
+(make-variable-buffer-local 'font-lock-cache-state)
+(make-variable-buffer-local 'font-lock-cache-position)
+
+(defun font-lock-lisp-like (mode)
+  ;; Note: (or (get mode 'font-lock-lisp-like) (string-match ...)) is
+  ;; not enough because the property needs to be able to specify a nil
+  ;; value.
+  (if (plist-member (symbol-plist mode) 'font-lock-lisp-like)
+      (get mode 'font-lock-lisp-like)
+    ;; If the property is not specified, guess.  Similar logic exists
+    ;; in add-log, but I think this encompasses more modes.
+    (string-match "lisp\\|scheme" (symbol-name mode))))
+
+;; fontify-syntactically-region used to use syntactically-sectionize, which
+;; was supposedly much faster than the FSF version because it was written in
+;; C. However, the FSF version uses parse-partial-sexp, which is also
+;; written in C, and the benchmarking I did showed the
+;; syntactically-sectionize code to be slower overall. So here's the FSF
+;; version, modified to support font-lock-doc-string-face.
+;; -- mct 2000-12-29
+;; Now synched with 21.2. --ben
+(defun font-lock-fontify-syntactically-region (start end &optional loudly)
+  "Put proper face on each string and comment between START and END.
 START should be at the beginning of a line."
-;;  ;; If `font-lock-syntactic-keywords' is a symbol, get the real keywords.
-  (when (symbolp font-lock-syntactic-keywords)
-    (setq font-lock-syntactic-keywords (font-lock-eval-keywords
-					font-lock-syntactic-keywords)))
-  ;; If `font-lock-syntactic-keywords' is not compiled, compile it.
-  (unless (eq (car font-lock-syntactic-keywords) t)
-    (setq font-lock-syntactic-keywords (font-lock-compile-keywords
-					font-lock-syntactic-keywords)))
-  ;; Get down to business.
-  (let ((case-fold-search font-lock-keywords-case-fold-search)
-	(keywords (cdr font-lock-syntactic-keywords))
-	keyword matcher highlights)
-    (while keywords
-      ;; Find an occurrence of `matcher' from `start' to `end'.
-      (setq keyword (car keywords) matcher (car keyword))
-      (goto-char start)
-      (while (if (stringp matcher)
-		 (re-search-forward matcher end t)
-	       (funcall matcher end))
-	;; Apply each highlight to this instance of `matcher', which may be
-	;; specific highlights or more keywords anchored to `matcher'.
-	(setq highlights (cdr keyword))
-	(while highlights
-	  (if (numberp (car (car highlights)))
-	      (font-lock-apply-syntactic-highlight (car highlights))
-	    (font-lock-fontify-syntactic-anchored-keywords (car highlights)
-							   end))
-	  (setq highlights (cdr highlights))))
-      (setq keywords (cdr keywords)))))
+  (let ((cache (marker-position font-lock-cache-position))
+	state face beg stringp) ;; STRINGP is XEmacs addition
+    ;; XEmacs: implement font-lock-message-threshold and progress bars.
+    (if (and loudly (>= (- end start) font-lock-message-threshold))
+	(progress-feedback-with-label
+	 'font-lock "Fontifying %s... (syntactically...)" 5
+	 (buffer-name)))
+    (goto-char start)
+    ;;
+    ;; Find the state at the `beginning-of-line' before `start'.
+    (if (eq start cache)
+	;; Use the cache for the state of `start'.
+	(setq state font-lock-cache-state)
+      ;; Find the state of `start'.
+      (if (null font-lock-beginning-of-syntax-function)
+	  ;; Use the state at the previous cache position, if any, or
+	  ;; otherwise calculate from `point-min'.
+	  (if (or (null cache) (< start cache))
+	      (setq state (parse-partial-sexp (point-min) start))
+	    (setq state (parse-partial-sexp cache start nil nil
+					    font-lock-cache-state)))
+	;; Call the function to move outside any syntactic block.
+	(funcall font-lock-beginning-of-syntax-function)
+	(setq state (parse-partial-sexp (point) start)))
+      ;; Cache the state and position of `start'.
+      (setq font-lock-cache-state state)
+      (set-marker font-lock-cache-position start))
+    ;;
+    ;; If the region starts inside a string or comment, show the extent of it.
+    (when (or (nth 3 state) (nth 4 state))
+      (setq face (funcall font-lock-syntactic-face-function state) beg (point))
+      (setq state (parse-partial-sexp (point) end nil nil state 'syntax-table))
+      ;; XEmacs change: call font-lock-set-face
+      (font-lock-set-face beg (point) face))
+    ;;
+    ;; Find each interesting place between here and `end'.
+    (while (and (< (point) end)
+		(progn
+		  (setq state (parse-partial-sexp (point) end nil nil state
+						  'syntax-table))
+		  (or (nth 3 state) (nth 4 state))))
+      (setq face (funcall font-lock-syntactic-face-function state)
+	    stringp (nth 3 state)
+	    beg (nth 8 state))
+      (setq state (parse-partial-sexp (point) end nil nil state 'syntax-table))
+      ;; XEmacs change: call font-lock-set-face, handle
+      ;; font-lock-fontify-string-delimiters.
+      (if (and stringp (not font-lock-fontify-string-delimiters))
+	  (font-lock-set-face (+ beg 1) (- (point) 1) face)
+	(font-lock-set-face beg (point) face)))))
+
+;;; End of Syntactic fontification functions.
+
 
 ;;; Regexp fontification functions.
 
 (defsubst font-lock-apply-highlight (highlight)
   "Apply HIGHLIGHT following a match.
 HIGHLIGHT should be of the form MATCH-HIGHLIGHT, see `font-lock-keywords'."
+  ;; XEmacs changes to this.  The FSF function is basically unchanged from
+  ;; 19.34 through 21.2 but we have some additions -- e.g. NEWFACE.
   (let* ((match (nth 0 highlight))
 	 (start (match-beginning match)) (end (match-end match))
 	 (override (nth 2 highlight)))
@@ -1610,17 +2283,27 @@
 KEYWORDS should be of the form MATCH-ANCHORED, see `font-lock-keywords',
 LIMIT can be modified by the value of its PRE-MATCH-FORM."
   (let ((matcher (nth 0 keywords)) (lowdarks (nthcdr 3 keywords)) highlights
+	(lead-start (match-beginning 0))
 	;; Evaluate PRE-MATCH-FORM.
 	(pre-match-value (eval (nth 1 keywords))))
     ;; Set LIMIT to value of PRE-MATCH-FORM or the end of line.
-    (if (and (numberp pre-match-value) (> pre-match-value (point)))
-	(setq limit pre-match-value)
-      (save-excursion (end-of-line) (setq limit (point))))
+    (if (not (and (numberp pre-match-value) (> pre-match-value (point))))
+	(setq limit (line-end-position))
+      (setq limit pre-match-value)
+      (when (and font-lock-multiline (>= limit (line-beginning-position 2)))
+	;; this is a multiline anchored match
+	;; (setq font-lock-multiline t)
+	(put-text-property (if (= limit (line-beginning-position 2))
+			       (1- limit)
+			     (min lead-start (point)))
+			   limit
+			   'font-lock-multiline t)))
     (save-match-data
       ;; Find an occurrence of `matcher' before `limit'.
-      (while (if (stringp matcher)
-		 (re-search-forward matcher limit t)
-	       (funcall matcher limit))
+      (while (and (< (point) limit)
+		  (if (stringp matcher)
+		      (re-search-forward matcher limit t)
+		    (funcall matcher limit)))
 	;; Apply each highlight to this instance of `matcher'.
 	(setq highlights lowdarks)
 	(while highlights
@@ -1629,10 +2312,11 @@
     ;; Evaluate POST-MATCH-FORM.
     (eval (nth 2 keywords))))
 
-(defun font-lock-fontify-keywords-region (start end &optional loudvar)
+(defun font-lock-fontify-keywords-region (start end &optional loudly)
   "Fontify according to `font-lock-keywords' between START and END.
 START should be at the beginning of a line."
-  (let ((loudly (and font-lock-verbose
+  ;; XEmacs addition: font-lock-message-threshold
+  (let ((loudly (and loudly
 		     (>= (- end start) font-lock-message-threshold))))
     ;; If `font-lock-keywords' is not compiled, compile it.
     (unless (eq (car-safe font-lock-keywords) t)
